#include "stdafx.h"
#include "MainForm.h"


using namespace Core;


// Constructor
MainForm::MainForm( void )
{
    // R|[lg
    InitializeComponent();

    // ... Ǝ̃R|[lg
    InitializeOriginalComponent();
}

// Destructor
MainForm::~MainForm()
{
    if( components != nullptr )
    {
        delete components;
    }

    // SAPIj
    delete m_sapi;


    // VA |[g
    m_serialPort->Close();
}


#pragma region Windows Form Designer generated code
/// <summary>
/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
/// R[h GfB^ŕύXȂłB
/// </summary>
void MainForm::InitializeComponent(void)
{
    this->components = (gcnew System::ComponentModel::Container());
    this->m_textBox = (gcnew System::Windows::Forms::TextBox());
    this->m_statusBar = (gcnew System::Windows::Forms::StatusStrip());
    this->m_statusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
    this->m_toolContainer = (gcnew System::Windows::Forms::ToolStripContainer());
    this->m_comboBox = (gcnew System::Windows::Forms::ComboBox());
    this->m_serialPort = (gcnew System::IO::Ports::SerialPort(this->components));
    this->m_label = (gcnew System::Windows::Forms::Label());
    this->m_copyRightLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
    this->m_statusBar->SuspendLayout();
    this->m_toolContainer->BottomToolStripPanel->SuspendLayout();
    this->m_toolContainer->ContentPanel->SuspendLayout();
    this->m_toolContainer->SuspendLayout();
    this->SuspendLayout();
    // 
    // m_textBox
    // 
    this->m_textBox->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
        | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
    this->m_textBox->Location = System::Drawing::Point(12, 90);
    this->m_textBox->Multiline = true;
    this->m_textBox->Name = L"m_textBox";
    this->m_textBox->ScrollBars = System::Windows::Forms::ScrollBars::Both;
    this->m_textBox->Size = System::Drawing::Size(320, 139);
    this->m_textBox->TabIndex = 0;
    // 
    // m_statusBar
    // 
    this->m_statusBar->Dock = System::Windows::Forms::DockStyle::None;
    this->m_statusBar->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->m_statusLabel, this->m_copyRightLabel});
    this->m_statusBar->Location = System::Drawing::Point(0, 0);
    this->m_statusBar->Name = L"m_statusBar";
    this->m_statusBar->Size = System::Drawing::Size(346, 22);
    this->m_statusBar->SizingGrip = false;
    this->m_statusBar->TabIndex = 2;
    this->m_statusBar->Text = L"statusBar";
    // 
    // m_statusLabel
    // 
    this->m_statusLabel->Name = L"m_statusLabel";
    this->m_statusLabel->Size = System::Drawing::Size(53, 17);
    this->m_statusLabel->Text = L"F";
    // 
    // m_toolContainer
    // 
    // 
    // m_toolContainer.BottomToolStripPanel
    // 
    this->m_toolContainer->BottomToolStripPanel->Controls->Add(this->m_statusBar);
    // 
    // m_toolContainer.ContentPanel
    // 
    this->m_toolContainer->ContentPanel->Controls->Add(this->m_label);
    this->m_toolContainer->ContentPanel->Controls->Add(this->m_comboBox);
    this->m_toolContainer->ContentPanel->Controls->Add(this->m_textBox);
    this->m_toolContainer->ContentPanel->Size = System::Drawing::Size(346, 263);
    this->m_toolContainer->Dock = System::Windows::Forms::DockStyle::Fill;
    this->m_toolContainer->LeftToolStripPanelVisible = false;
    this->m_toolContainer->Location = System::Drawing::Point(0, 0);
    this->m_toolContainer->Name = L"m_toolContainer";
    this->m_toolContainer->RightToolStripPanelVisible = false;
    this->m_toolContainer->Size = System::Drawing::Size(346, 285);
    this->m_toolContainer->TabIndex = 3;
    this->m_toolContainer->Text = L"toolContainer";
    this->m_toolContainer->TopToolStripPanelVisible = false;
    // 
    // m_comboBox
    // 
    this->m_comboBox->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right));
    this->m_comboBox->FormattingEnabled = true;
    this->m_comboBox->Location = System::Drawing::Point(258, 235);
    this->m_comboBox->Name = L"m_comboBox";
    this->m_comboBox->Size = System::Drawing::Size(74, 20);
    this->m_comboBox->Sorted = true;
    this->m_comboBox->TabIndex = 1;
    this->m_comboBox->SelectedIndexChanged += gcnew System::EventHandler(this, &MainForm::m_comboBox_SelectedIndexChanged);
    // 
    // m_serialPort
    // 
    this->m_serialPort->BaudRate = 115200;
    this->m_serialPort->DtrEnable = true;
    this->m_serialPort->ReadTimeout = 10;
    this->m_serialPort->WriteTimeout = 10;
    // 
    // m_label
    // 
    this->m_label->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Bottom | System::Windows::Forms::AnchorStyles::Right));
    this->m_label->AutoSize = true;
    this->m_label->Location = System::Drawing::Point(195, 238);
    this->m_label->Name = L"m_label";
    this->m_label->Size = System::Drawing::Size(57, 12);
    this->m_label->TabIndex = 2;
    this->m_label->Text = L"ʐM|[g";
    // 
    // m_copyRightLabel
    // 
    this->m_copyRightLabel->Name = L"m_copyRightLabel";
    this->m_copyRightLabel->Size = System::Drawing::Size(247, 17);
    this->m_copyRightLabel->Spring = true;
    this->m_copyRightLabel->Text = L"(C)2007 Minoru BABA";
    this->m_copyRightLabel->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
    // 
    // MainForm
    // 
    this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
    this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
    this->ClientSize = System::Drawing::Size(346, 285);
    this->Controls->Add(this->m_toolContainer);
    this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
    this->MaximizeBox = false;
    this->MinimizeBox = false;
    this->Name = L"MainForm";
    this->Text = L"VoiceCommander";
    this->m_statusBar->ResumeLayout(false);
    this->m_statusBar->PerformLayout();
    this->m_toolContainer->BottomToolStripPanel->ResumeLayout(false);
    this->m_toolContainer->BottomToolStripPanel->PerformLayout();
    this->m_toolContainer->ContentPanel->ResumeLayout(false);
    this->m_toolContainer->ContentPanel->PerformLayout();
    this->m_toolContainer->ResumeLayout(false);
    this->m_toolContainer->PerformLayout();
    this->ResumeLayout(false);

}
#pragma endregion

// Ǝ̃R|[lg
void MainForm::InitializeOriginalComponent()
{
    // Rg[̃CAEgWbN𒆒f
    this->SuspendLayout();

    this->m_button = gcnew array< System::Windows::Forms::Button^ >( m_buttonSum );

    for( int i=0; i < m_button->Length; i++ )
    {
        const int row = 3;

        System::Windows::Forms::Button^ newButton = gcnew System::Windows::Forms::Button();
        // 
        // m_button
        // 
        this->m_button[ i ] = newButton;
        newButton->AutoEllipsis = true;
        newButton->Location = System::Drawing::Point(12 + ( i - ( i / row ) * row ) * 110, 12 + ( i / row ) * 25 );
        newButton->Name = L"m_button";
        newButton->Size = System::Drawing::Size(100, 23);
        newButton->TabIndex = 1;
        newButton->Tag = i + 1;
        newButton->Text = ( i + 1 ).ToString();
        newButton->UseVisualStyleBackColor = true;
        newButton->Click += gcnew System::EventHandler(this, &MainForm::ButtonClick);
        //
        //
        //
        this->m_toolContainer->ContentPanel->Controls->Add( newButton );
    }


    m_button[ 2 -1 ]->Text = "O֐i";
    m_button[ 5 -1 ]->Text = "~܂";
    m_button[ 8 -1 ]->Text = "։";
    m_button[ 4 -1 ]->Text = "։";
    m_button[ 6 -1 ]->Text = "E։";


    // Rg[̃CAEgWbNĊJ
    this->ResumeLayout( false );
}


// tH[\
void MainForm::OnLoad( System::EventArgs^ e )
{
    // {NX̓֐Ăяo
    Windows::Forms::Form::OnLoad( e );


    // LȃVA |[g擾
    array< Object^ >^ portNames = m_serialPort->GetPortNames();

    // ... hbv_Eɒǉ
    m_comboBox->Items->AddRange( portNames );


    // SAPI\z
    m_sapi = gcnew SAPI::Recognition();

    // SAPĨAZu擾
    System::Reflection::Assembly^ assembly = System::Reflection::Assembly::GetAssembly( m_sapi->GetType() );

    // ... ̖̂o͂
    Debug::WriteLine( assembly->FullName );


    // ... EBhEnh^ SAPI
    if( !m_sapi->Init( this->Handle, L"grammar.xml" ) )
    {
        // ɎsȂ΁AtH[
        this->Close();
    }
}


// |[gIꂽ
Void MainForm::m_comboBox_SelectedIndexChanged(System::Object^  , System::EventArgs^ )
{
    // |[g
    m_serialPort->Close();


    // |[g擾
    String^ portName = m_comboBox->SelectedItem->ToString();

    
    this->m_serialPort->PortName = portName;

    // VA |[gJ
    this->m_serialPort->Open();

}


// Windows bZ[W
void MainForm::WndProc( Windows::Forms::Message% message )
{
    switch( message.Msg )
    {
        case SAPI::Recognition::REC_EVENT:

            // FCxg
            OnRecognition();
            break;
    }

    // {NX̓֐Ăяo
    Windows::Forms::Form::WndProc( message );
}


// FCxg
void MainForm::OnRecognition()
{
    int eventID;

    // FCxg擾
    while( ( eventID = m_sapi->GetRecognitionEvent() ) != 0 )
    {
        switch( eventID )
        {
            case SAPI::Recognition::SOUND_START:
                // Jnꂽ
                break;

            case SAPI::Recognition::SOUND_END:
                // Iꂽ
                break;

            case SAPI::Recognition::RECOGNITION:
                // Fꂽ
                Recognized();
                break;

            case SAPI::Recognition::FALSE_RECOGNITION:
                // FɎs
                break;

            default:
                Debug::Fail( "\ȂCxgԂꂽ" );
        }

        // F̏Ԃ Xe[^X o[ɕ\
        this->m_statusLabel->Text = m_sapi->GetState( eventID );
    }
}

// Fꂽ
void MainForm::Recognized()
{
    System::String^ text;

    // Fʂ擾
    if( m_sapi->GetRecognitionResult( text ) )
    {
        // eLXg{bNXɕ\
        this->m_textBox->AppendText( text + Environment::NewLine );


        for each( Windows::Forms::Button^ button in m_button )
        {
            if( button->Text == text )
            {
                // {^̃eLXgƈvĂȂ΁Ã{^NbN
                button->PerformClick();
            }
        }
    }
}


// {^NbNꂽ
System::Void MainForm::ButtonClick( System::Object^  sender, System::EventArgs^ )
{
    // |[gJĂȂȂ΁AȂ
    if( !m_serialPort->IsOpen ) return;


    // ̃CX^XړǏ^ɃLXg
    Windows::Forms::Button^ button = safe_cast< Windows::Forms::Button^ >( sender );

    Debug::Assert( m_serialPort->IsOpen, "|[g͊JĂ" );


    // {^̔ԍ擾
    int buttonIndex = safe_cast< int >( button->Tag );

    // ... R}h𑗐M
    m_serialPort->Write( buttonIndex.ToString() );


/*
    // ȉ́AԊO̔R[hPCŐ䂷ꍇ̂

    array< Byte >^ data = gcnew array< Byte >( 13 );
    data[  0 ] = 0xF0;
    data[  1 ] = 32;
    data[  2 ] = 0x07;
    data[  3 ] = 0x06; 
    data[  4 ] = 22; 
    data[  5 ] = 22 ; 
    data[  6 ] = 11 ;
    data[  7 ] = 11 ;
    data[  8 ] = 0x00;
    data[  9 ] = 0x18;
    data[ 10 ] = 0xE7;
    data[ 11 ] = 0x88;
    data[ 12 ] = 0x77;

    m_serialPort->Write( data, 0, 13 );
*/


    Debug::WriteLine( System::String::Format( "{^NbNꂽ : {0}", buttonIndex ) );
}
